// **********************************************************************
//
// Copyright (c) 2001 MT Tools.
//
// All Rights Reserved
//
// MT_DORB is based in part on the product DORB,
// written by Shadrin Victor
//
// See Readme.txt for contact information
//
// **********************************************************************
unit imr_impl;

interface

uses
  imr_int,imr,Classes,req_int,orb_int,orbtypes,env_int,SysUtils,code_int;

{$IFNDEF USELIB}

type

  TImplRepository_impl = class(TImplRepository_skel,IORBObject,IImplRepository,IImplementationBase)
  private
    FDefs : IInterfaceList;
  protected
    function find_by_name(name: string): IInterfaceList; override;
    function make_request(const req: IORBRequest;const obj: IORBObject; mid: ORBMessageID;
       const oa: IObjectAdaptor; pr: IPrincipal):IServerRequestBase; override;
    procedure doinvoke(const req: IServerRequestBase; const env: IEnvironment); override;
    function _create(mode : TActivationMode;const objs: IInterfaceList;
      name: string; command: string): IImplementationDef; override;
  public
    constructor Create();
  end;

  TImplementationDef_impl = class(TImplementationDef_skel)
  private
    FMode: TActivationMode;
    FObjs : IInterfaceList;
    FName: string;
    FCommand : string;
  protected
    function name(): string; override;
  public
    constructor Create(mode: TActivationMode; const objs: IInterfaceList; name: string; command: string);
  end;

implementation

//**************************************************************************
// TImplRepository_impl
//**************************************************************************
constructor TImplRepository_impl.Create;
begin
  inherited Create();
  FDefs := TInterfaceList.Create;
end;

function TImplRepository_impl.make_request(const req: IORBRequest;const obj: IORBObject; mid: ORBMessageID;
       const oa: IObjectAdaptor; pr: IPrincipal):IServerRequestBase;
begin
  assert(false,'not implemented');
end;

procedure TImplRepository_impl.doinvoke(const req: IServerRequestBase; const env : IEnvironment);
begin
  assert(false,'not implemented');
end;

function TImplRepository_impl.find_by_name(name: string): IInterfaceList;
var
  i : integer;
begin
  result := TInterfaceList.Create;
  for i := 0 to Pred(FDefs.Count) do
    if strcomp(PChar(name),PChar(IImplementationDef(FDefs[i]).name)) = 0 then
      result.Add(IImplementationDef(FDefs[i]));
end;

function TImplRepository_impl._create(mode : TActivationMode;const objs: IInterfaceList;
      name: string; command: string): IImplementationDef;
begin
  result := TImplementationDef_impl.Create(mode,objs,name,command);
  FDefs.Add(result);
end;

//*********************************************************************
//  TImplementationDef_impl
//*********************************************************************
constructor TImplementationDef_impl.Create(mode: TActivationMode;
  const objs: IInterfaceList; name, command: string);
begin
  FMode := mode;
  FObjs := objs;
  FName := name;
  FCommand := command;
end;

function TImplementationDef_impl.name: string;
begin
  result := FName;
end;

{$ELSE}
implementation
{$ENDIF}
end.
